(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/cdk/coercion'), require('@angular/forms'), require('@angular/material'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('ngx8-mat-codemirror', ['exports', '@angular/core', '@angular/cdk/coercion', '@angular/forms', '@angular/material', 'rxjs'], factory) :
    (global = global || self, factory(global['ngx8-mat-codemirror'] = {}, global.ng.core, global.ng.cdk.coercion, global.ng.forms, global.ng.material, global.rxjs));
}(this, (function (exports, core, coercion, forms, material, rxjs) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var MatCodemirrorComponent = /** @class */ (function () {
        function MatCodemirrorComponent(ngControl, // mat
        _differs, _ngZone) {
            this.ngControl = ngControl;
            this._differs = _differs;
            this._ngZone = _ngZone;
            this.stateChanges = new rxjs.Subject();
            this.id = "mat-codemirror-component-" + MatCodemirrorComponent_1.materialId++;
            this.describedBy = '';
            this.onChange = function (_) { return null; };
            this.onTouched = function () { return null; };
            this._required = false;
            this._focused = false;
            this._disabled = false;
            this._value = '';
            this.ngxMatCodemirror = true;
            /* class applied to the created textarea */
            this.className = '';
            /* name applied to the created textarea */
            this.name = 'codemirror';
            /* autofocus setting applied to the created textarea */
            this.autoFocus = false;
            /* preserve previous scroll position after updating value */
            this.preserveScrollPosition = false;
            /* called when the text cursor is moved */
            this.cursorActivity = new core.EventEmitter();
            /* called when the editor is focused or loses focus */
            this.focusChange = new core.EventEmitter();
            /* called when the editor is scrolled */
            this.scroll = new core.EventEmitter();
            if (this.ngControl != null) {
                this.ngControl.valueAccessor = this;
            }
        }
        MatCodemirrorComponent_1 = MatCodemirrorComponent;
        Object.defineProperty(MatCodemirrorComponent.prototype, "shouldLabelFloat", {
            get: function () {
                return this.focused || !this.empty;
            },
            enumerable: true,
            configurable: true
        });
        MatCodemirrorComponent.prototype.setDescribedByIds = function (ids) {
            this.describedBy = ids.join(' ');
        };
        MatCodemirrorComponent.prototype.onContainerClick = function (event) { };
        Object.defineProperty(MatCodemirrorComponent.prototype, "required", {
            get: function () {
                return this._required;
            },
            set: function (req) {
                this._required = coercion.coerceBooleanProperty(req);
                this.stateChanges.next();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatCodemirrorComponent.prototype, "errorState", {
            get: function () {
                return this.ngControl && !this.ngControl.pristine && !this.ngControl.valid;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatCodemirrorComponent.prototype, "placeholder", {
            get: function () {
                return this._placeholder;
            },
            set: function (plh) {
                this._placeholder = plh;
                this.stateChanges.next();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatCodemirrorComponent.prototype, "empty", {
            get: function () {
                return !this.value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatCodemirrorComponent.prototype, "value", {
            get: function () {
                return this._value;
            },
            set: function (value) {
                this._value = value;
                this.updateLineNumbers();
                this.stateChanges.next();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatCodemirrorComponent.prototype, "disabled", {
            get: function () {
                return this._disabled;
            },
            set: function (dis) {
                this._disabled = coercion.coerceBooleanProperty(dis);
                this.stateChanges.next();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatCodemirrorComponent.prototype, "focused", {
            get: function () {
                return this._focused;
            },
            set: function (val) {
                this._focused = val;
                this.stateChanges.next();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MatCodemirrorComponent.prototype, "options", {
            /**
             * set options for codemirror
             * @link http://codemirror.net/doc/manual.html#config
             */
            set: function (value) {
                this._options = value;
                if (!this._differ && value) {
                    this._differ = this._differs.find(value).create();
                }
            },
            enumerable: true,
            configurable: true
        });
        MatCodemirrorComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            if (!this.ref) {
                return;
            }
            // in order to allow for universal rendering, we import Codemirror runtime with `require` to prevent node errors
            var fromTextArea = require('codemirror').fromTextArea;
            this.codeMirror = fromTextArea(this.ref.nativeElement, this._options);
            this.updateLineNumbers();
            this._ngZone.runOutsideAngular(function () {
                _this.codeMirror.on('change', _this.codemirrorValueChanged.bind(_this));
                _this.codeMirror.on('cursorActivity', _this.cursorActive.bind(_this));
                _this.codeMirror.on('focus', _this.focusChanged.bind(_this, true));
                _this.codeMirror.on('blur', _this.focusChanged.bind(_this, false));
                _this.codeMirror.on('scroll', _this.scrollChanged.bind(_this));
            });
            this.codeMirror.setValue(this.value);
        };
        MatCodemirrorComponent.prototype.ngDoCheck = function () {
            var _this = this;
            if (this._differ) {
                // check options have not changed
                var changes = this._differ.diff(this._options);
                if (changes) {
                    changes.forEachChangedItem(function (option) {
                        return _this.setOptionIfChanged(option.key, option.currentValue);
                    });
                    changes.forEachAddedItem(function (option) {
                        return _this.setOptionIfChanged(option.key, option.currentValue);
                    });
                    changes.forEachRemovedItem(function (option) {
                        return _this.setOptionIfChanged(option.key, option.currentValue);
                    });
                }
            }
        };
        MatCodemirrorComponent.prototype.ngOnDestroy = function () {
            // is there a lighter-weight way to remove the cm instance?
            if (this.codeMirror) {
                this.codeMirror.toTextArea();
            }
            this.stateChanges.complete();
        };
        MatCodemirrorComponent.prototype.codemirrorValueChanged = function (cm, change) {
            if (change.origin !== 'setValue') {
                this.value = cm.getValue();
                this.writeValue(cm.getValue());
            }
        };
        MatCodemirrorComponent.prototype.setOptionIfChanged = function (optionName, newValue) {
            if (!this.codeMirror) {
                return;
            }
            this.codeMirror.setOption(optionName, newValue);
        };
        MatCodemirrorComponent.prototype.focusChanged = function (focused) {
            this.onTouched();
            this.focused = focused;
            this.focusChange.emit(focused);
        };
        MatCodemirrorComponent.prototype.scrollChanged = function (cm) {
            this.scroll.emit(cm.getScrollInfo());
        };
        MatCodemirrorComponent.prototype.cursorActive = function (cm) {
            this.cursorActivity.emit(cm);
        };
        MatCodemirrorComponent.prototype.writeValue = function (value) {
            if (!this.codeMirror) {
                if (value) {
                    this.value = value;
                }
                return;
            }
            if (value == null) {
                value = '';
            }
            if (value !== this.codeMirror.getValue() &&
                this.normalizeLineEndings(this.codeMirror.getValue()) !==
                    this.normalizeLineEndings(value)) {
                this.value = value;
                if (this.preserveScrollPosition) {
                    var prevScrollPosition = this.codeMirror.getScrollInfo();
                    this.codeMirror.setValue(this.value);
                    this.codeMirror.scrollTo(prevScrollPosition.left, prevScrollPosition.top);
                    return;
                }
                this.codeMirror.setValue(this.value);
                // Don't call onChange value is from ngModel
                return;
            }
            this.onChange(this.value);
        };
        MatCodemirrorComponent.prototype.registerOnChange = function (fn) {
            this.onChange = fn;
        };
        MatCodemirrorComponent.prototype.registerOnTouched = function (fn) {
            this.onTouched = fn;
        };
        MatCodemirrorComponent.prototype.setDisabledState = function (isDisabled) {
            this.disabled = isDisabled;
            this.setOptionIfChanged('readOnly', this.disabled);
        };
        MatCodemirrorComponent.prototype.normalizeLineEndings = function (str) {
            return (str || '').replace(/\r\n|\r/g, '\n');
        };
        MatCodemirrorComponent.prototype.updateLineNumbers = function () {
            if (this.codeMirror) {
                this.codeMirror.setOption('lineNumbers', !!/\n/.test(this._value));
            }
        };
        var MatCodemirrorComponent_1;
        MatCodemirrorComponent.materialId = 0;
        MatCodemirrorComponent.ctorParameters = function () { return [
            { type: forms.NgControl, decorators: [{ type: core.Optional }, { type: core.Self }] },
            { type: core.KeyValueDiffers },
            { type: core.NgZone }
        ]; };
        __decorate([
            core.HostBinding()
        ], MatCodemirrorComponent.prototype, "id", void 0);
        __decorate([
            core.HostBinding('attr.aria-describedby')
        ], MatCodemirrorComponent.prototype, "describedBy", void 0);
        __decorate([
            core.HostBinding('class.ngx-mat-codemirror')
        ], MatCodemirrorComponent.prototype, "ngxMatCodemirror", void 0);
        __decorate([
            core.Input()
        ], MatCodemirrorComponent.prototype, "className", void 0);
        __decorate([
            core.Input()
        ], MatCodemirrorComponent.prototype, "name", void 0);
        __decorate([
            core.Input()
        ], MatCodemirrorComponent.prototype, "autoFocus", void 0);
        __decorate([
            core.Input()
        ], MatCodemirrorComponent.prototype, "preserveScrollPosition", void 0);
        __decorate([
            core.Output()
        ], MatCodemirrorComponent.prototype, "cursorActivity", void 0);
        __decorate([
            core.Output()
        ], MatCodemirrorComponent.prototype, "focusChange", void 0);
        __decorate([
            core.Output()
        ], MatCodemirrorComponent.prototype, "scroll", void 0);
        __decorate([
            core.ViewChild('ref', { static: true })
        ], MatCodemirrorComponent.prototype, "ref", void 0);
        __decorate([
            core.HostBinding('class.floating')
        ], MatCodemirrorComponent.prototype, "shouldLabelFloat", null);
        __decorate([
            core.Input()
        ], MatCodemirrorComponent.prototype, "required", null);
        __decorate([
            core.Input()
        ], MatCodemirrorComponent.prototype, "placeholder", null);
        __decorate([
            core.Input()
        ], MatCodemirrorComponent.prototype, "disabled", null);
        __decorate([
            core.Input()
        ], MatCodemirrorComponent.prototype, "options", null);
        MatCodemirrorComponent = MatCodemirrorComponent_1 = __decorate([
            core.Component({
                selector: 'mat-codemirror',
                template: "<textarea\n  [name]=\"name\"\n  class=\"ngx-codemirror {{ className }}\"\n  [class.ngx-codemirror--focused]=\"focused\"\n  autocomplete=\"off\"\n  [autofocus]=\"autoFocus\"\n  #ref>\n</textarea>\n",
                providers: [
                    {
                        provide: material.MatFormFieldControl,
                        useExisting: MatCodemirrorComponent_1
                    }
                ],
                preserveWhitespaces: false,
                changeDetection: core.ChangeDetectionStrategy.OnPush,
                encapsulation: core.ViewEncapsulation.None,
                styles: [".ngx-mat-codemirror .CodeMirror{height:auto}.ngx-mat-codemirror .CodeMirror-scroll{max-height:250px}"]
            }),
            __param(0, core.Optional()), __param(0, core.Self())
        ], MatCodemirrorComponent);
        return MatCodemirrorComponent;
    }());

    var MatCodemirrorModule = /** @class */ (function () {
        function MatCodemirrorModule() {
        }
        MatCodemirrorModule = __decorate([
            core.NgModule({
                declarations: [
                    MatCodemirrorComponent,
                ],
                exports: [
                    MatCodemirrorComponent,
                ]
            })
        ], MatCodemirrorModule);
        return MatCodemirrorModule;
    }());

    exports.MatCodemirrorModule = MatCodemirrorModule;
    exports.ɵa = MatCodemirrorComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx8-mat-codemirror.umd.js.map
